unit unitBoard;// alexlaw@list.ru

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, Clipbrd;

type
  TBoardChess = class(TForm)
    Board: TImage;///  /
    Desk: TImage;//   
    Piece: TImage;//  
    SelectBox: TImage;
    Lamp: TImage;
    cheh: TImage;
    mat: TImage;
    MenuHiPawn: TPopupMenu;
    Qween: TMenuItem;
    Rook: TMenuItem;
    Bishop: TMenuItem;
    Knight: TMenuItem;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    PieceMirror: TImage; 
    N5: TMenuItem;
    N4: TMenuItem;
    FigureMenu: TPopupMenu;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    PerftResult: TMenuItem;
    Memo1: TMemo;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    STOP1: TMenuItem;
    N20: TMenuItem;
    N110: TMenuItem;
    N22: TMenuItem;
    N32: TMenuItem;
    N42: TMenuItem;
    N52: TMenuItem;
    N62: TMenuItem;
    FEN1: TMenuItem;
    FEN2: TMenuItem;
    N23: TMenuItem;
    procedure N23Click(Sender: TObject);
    procedure FEN1Click(Sender: TObject);
    procedure N62Click(Sender: TObject);
    procedure N52Click(Sender: TObject);
    procedure N42Click(Sender: TObject);
    procedure N32Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure N110Click(Sender: TObject);
    procedure STOP1Click(Sender: TObject);
    procedure N81Click(Sender: TObject);
    procedure N71Click(Sender: TObject);
    procedure N61Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N41Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N21Click(Sender: TObject);  
    procedure N19Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject); 
    procedure N3Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure KnightClick(Sender: TObject);
    procedure BishopClick(Sender: TObject);
    procedure RookClick(Sender: TObject);
    procedure QweenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BoardClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;
procedure init(color:integer);
procedure DrawLine(a,b:Integer;WP,BP:array of  UInt64);
procedure RefreshDesk(WP,BP:array of  UInt64);
function U64toFen(WP,BP:array  of  UInt64;col:Integer):WideString;
var
  BoardChess: TBoardChess;
MirrorP:boolean=false;
MenuArray:array [0..11]  of  TMenuItem;
//StrFen:string='';
//(1152921504606846976,576460752303423488,9295429630892703744,2594073385365405696,4755801206503243776,71776119061217280);
WPieceStart: array [0..5]  of  UInt64 = (1152921504606846976,576460752303423488,9295429630892703744,2594073385365405696,4755801206503243776,71776119061217280);//  
//(16,8,129,36,66,65280);
BPieceStart: array [0..5]  of  UInt64 = (16,8,129,36,66,65280);
WPiece: array [0..5]  of  UInt64;
BPiece: array [0..5]  of  UInt64;
NewVar:boolean;
MovPriore:string='';
FromTo,ToFrom,NumPoz,ColorMove,SelectFigure,clic,dmax: Integer;
depth:Integer=2;
SelectPawnHi:Integer=1;
Xmouse,Ymouse:Integer;
 MP:UInt64;
 BotW:Boolean=false;
 BotB:Boolean=false;//false;
 TinkSwch:Boolean=false;
 MaskOneBit: array [0..63]  of  UInt64 = (
  1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536,131072,262144,
  524288,1048576,2097152,4194304,8388608,16777216,33554432,67108864,134217728,
  268435456,536870912,1073741824,2147483648,4294967296,8589934592,17179869184,
  34359738368,68719476736,137438953472,274877906944,549755813888,1099511627776,
  2199023255552,4398046511104,8796093022208,17592186044416,35184372088832,
  70368744177664,140737488355328,281474976710656,562949953421312,1125899906842624,
  2251799813685248,4503599627370496,9007199254740992,18014398509481984,36028797018963968,
  72057594037927936,144115188075855872,288230376151711744,576460752303423488,
  1152921504606846976,2305843009213693952,4611686018427387904,9223372036854775808);
 t1,t2,t:UInt64;
implementation

uses Unit2;

{$R *.dfm}
function RDTSC: UInt64;
asm
 rdtsc
end;
function U64toFen(WP,BP:array  of  UInt64;col:Integer):WideString;
var
i,ii,j,z,swth,k:Integer;
strF,strN,strK,FenString:string;
Figure:UInt64;
begin
result:='';
strF:='KQRBNPkqrbnp';
FenString:='';
Figure:=0;
ii:=64;
      for i := 0 to 5 do begin
        Figure:=Figure or WP[i] or BP[i];
      end;
        for i:=63 downto 0 do  begin // i-  
            j := (Figure shr i) and 1;//j-  
                case j  of
                     1:begin
                       for z := 5 downto 0 do begin
                         if (MaskOneBit[i] and WP[z])>0 then begin swth:=z+1;break; end;
                         if (MaskOneBit[i] and BP[z])>0 then begin swth:=z+7;break; end;
                       end;//  
                     k:=ii-i;
                     StrK:=IntToStr(k-1);
                     if k=1 then StrK:='';
                     strN:=copy(strF,swth,1) + StrK;
                     FenString:=strN+FenString;
                     ii:=i;
                     end;//1
                end;//case
        if (i mod 8)=0 then begin
                     k:=ii-i;
                     StrK:=IntToStr(k);
                     if k=0 then StrK:='';
                     if i>0 then begin
                       FenString:='/'+strK+FenString;
                     end else FenString:=strK+FenString;
                     ii:=ii-k;
        end;//if
        end;//for
  case col of
     0:FenString:=FenString+' w ';
     1:FenString:=FenString+' b ';
  end;
result:=FenString;
end;
function FenToU64(sfen:String):boolean;
var
i,j,k,n,num:integer;
strN,strF,s01:string;
 WPieceNew: array [0..5]  of  UInt64;
 BPieceNew: array [0..5]  of  UInt64;
begin
   for i := 0 to 5 do  begin
    WPieceNew[i]:=0;
    BPieceNew[i]:=0;
   end;
   //if sfen='' then exit;
   strN:='12345678';
   strF:='KQRBNPkqrbnp';
   k:=length(sfen);
   n:=-1;num:=0;
      for i := 1 to k do begin
         s01:=copy(sfen,i,1);
         num:=pos(s01,strN);
         if s01='/' then continue;
         if s01=' ' then break;
         if num=0 then begin
              n:=n+1;
         end else begin
              n:=n+num;
         end;
         if n>63 then exit;         
          num:=pos(s01,strF);
          if num>0 then begin
            if num<7 then begin
               WPieceNew[num-1]:=WPieceNew[num-1] or MaskOneBit[n];
            end else begin
               BPieceNew[num-7]:=BPieceNew[num-7] or MaskOneBit[n];
            end;
          end;

      end;
for i := 0 to 5 do  begin
    WPieceStart[i]:=WPieceNew[i];
    BPieceStart[i]:=BPieceNew[i];
end;
  result:=false;
  if WPieceStart[0]=0 then begin  ShowMessage(' ');exit;end;
  if BPieceStart[0]=0 then begin  ShowMessage(' ');exit;end;
  init(0);
  result:=true;
end;
procedure MirrorDesc ();
var
bmp: tbitmap;
begin
 try
 bmp := tbitmap.Create;
 bmp.Width:=480;
 bmp.Height:=480;
 bmp.Canvas.CopyRect(rect(0,0,480,480),BoardChess.Board.Canvas,rect(504,500,24,20));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 BoardChess.Board.Canvas.Draw(24, 20, bmp);
 finally
 bmp.free;
 end;
end;
procedure MirrorBoard ();
var
bmp1,bmp2: tbitmap;
begin
 try
 bmp1:= tbitmap.Create;
 bmp1.Width:=528;
 bmp1.Height:=527;
 bmp2:= tbitmap.Create;
 bmp2.Width:=482;
 bmp2.Height:=487;
 bmp2.Canvas.Brush.Color:=clWhite;
 bmp2.Canvas.FillRect(Rect(0,0,bmp2.Width,bmp2.Height));
 bmp1.Canvas.CopyRect(rect(0,0,528,527),BoardChess.Board.Canvas,rect(528,527,0,0));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 BoardChess.Board.Canvas.Draw(0, 0, bmp1);
 BoardChess.Board.Canvas.Draw(22, 20, bmp2);
 finally
 bmp1.free;
 bmp2.free;
 end;
end;
procedure changeMove ();
var m,f:integer;
begin
if MirrorP then begin
  f:=0;
end else  f:=500;
//m:=returnMat();
      BoardChess.Cheh.Visible:=false;
      BoardChess.mat.Visible:=false;
 case ColorMove of
             0:begin
                //BoardChess.Cheh.Visible:=returnCheh(1);
                ColorMove:=1;
                BoardChess.Lamp.Top:=500-f;
                BoardChess.cheh.Top:=500-f;
                BoardChess.mat.Top:=500-f; 
               end;
              1:begin
                //BoardChess.Cheh.Visible:=returnCheh(0);
                ColorMove:=0;
                BoardChess.Lamp.Top:=0+f;
                BoardChess.cheh.Top:=0+f;
                BoardChess.mat.Top:=0+f;
              end;
 end;
 case m of
      4,8:BoardChess.Cheh.Visible:=true;
      1,2:BoardChess.mat.Visible:=true;
      else begin
            BoardChess.mat.Visible:=false;
      end;
 end;
end;
procedure ClearDesk ();
var
bmp: tbitmap;
begin
try
 bmp := tbitmap.Create;
 bmp.Height:=480;
 bmp.Width:=480;
 bmp.Canvas.CopyRect(rect(0,0,480,480),BoardChess.Desk.Canvas,rect(0,0,480,480));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 BoardChess.Board.Canvas.Draw(24, 20, bmp);
finally
 bmp.free;
end;
end;
procedure DrawPiece(Poz,NumP,ColorP: Integer);
var
bmp: tbitmap;
a,b: Integer;
begin
try
 bmp := tbitmap.Create;
 bmp.Height:=60;
 bmp.Width:=60;
a:=Poz and 7;
b:=Poz shr 3;
if MirrorP then begin
   bmp.Canvas.CopyRect(rect(0,0,60,60),BoardChess.PieceMirror.Canvas,rect(60*NumP,60*ColorP,60*NumP+60,60*ColorP+60));
end else begin
   bmp.Canvas.CopyRect(rect(0,0,60,60),BoardChess.Piece.Canvas,rect(60*NumP,60*ColorP,60*NumP+60,60*ColorP+60));
end;
bmp.TransparentColor:=clYellow;
bmp.Transparent:=true;
BoardChess.Board.Canvas.Draw(24+60*a, 20+60*b, bmp);
finally
 bmp.free;
end;
end; 
procedure DrawPieceBoard(APiece:array of  UInt64;ColorPiece: Integer);
var
NumPiece: Integer;
i,j: Integer;
begin
NumPiece:=0;
                          while NumPiece<6 do begin
                                  for i:=63 downto 0 do  begin
                                  j := (APiece[NumPiece] shr i) and 1;
                                       case j  of
                                                 1:begin
                                                   DrawPiece(i,NumPiece,ColorPiece);
                                                  end;
                                       end;
                                   end;
                            NumPiece:=NumPiece+1;
                            end;

end;
procedure lightPiece (Poz: Integer);
var
a,b: Integer;
begin
 a:=Poz and 7;
 b:=Poz shr 3;
 BoardChess.SelectBox.Top:=20+60*b;
 BoardChess.SelectBox.Left:=24+60*a;
 BoardChess.SelectBox.Visible:=true;
end;
procedure DrawMoveBox(u:UInt64);
var
bmp: tbitmap;
a,b,i,j: Integer;
begin
try
 j:=0;
 bmp := tbitmap.Create;
 bmp.Height:=60;
 bmp.Width:=60;
bmp.TransparentColor:=clWhite;
bmp.Transparent:=true;
bmp.Canvas.CopyRect(rect(0,0,60,60),BoardChess.Piece.Canvas,rect(360,0,420,60));
                                  for i:=63 downto 0 do  begin
                                  j := (u shr i) and 1;
                                       case j  of
                                                 1:begin
                                                  a:=i and 7;
                                                  b:=i shr 3;
                                                  BoardChess.Board.Canvas.Draw(24+60*a, 20+60*b, bmp);
                                                  end;
                                       end;
                                   end;
finally
  bmp.free;
end;
end;
procedure RefreshDesk(WP,BP:array of  UInt64);
begin
ClearDesk ();
DrawPieceBoard(WP,0);
DrawPieceBoard(BP,1);
BoardChess.Visible:=true;
BoardChess.Activate;
end;
procedure init(color:integer);
var
i,f:Integer;
begin 
BoardChess.Cursor:=crDefault;
NewVar:=true;
BoardChess.N3.Checked:=false;
BotW:=false;
BoardChess.N19.Checked:=false;
BotB:=false;
dmax:=depth;
//BoardChess.Board.ShowHint:=true;
 for i := 0 to 5 do begin
    WPiece[i]:=WPieceStart[i];
    BPiece[i]:=BPieceStart[i];
 end;
 f:=0;
if MirrorP then f:=500;
 case color of
     0:begin
                BoardChess.Lamp.Top:=500-f;
                BoardChess.cheh.Top:=500-f;
                BoardChess.mat.Top:=500-f;
  clic:=0;
  ColorMove:=0;
     end;
     1:begin
                BoardChess.Lamp.Top:=0+f;
                BoardChess.cheh.Top:=0+f;
                BoardChess.mat.Top:=0+f;
  clic:=0;
  ColorMove:=1;
     end;
 end;
  BoardChess.Cheh.Visible:=false;
  BoardChess.mat.Visible:=false;
  BoardChess.Lamp.Visible:=true;
  BoardChess.Board.Visible:=true;
FromTo:=0;
ToFrom:=0;
SelectFigure := -1;
SelectPawnHi:=1;
//resetFlagKing00(0,2); resetFlagKing00(1,2); resetFlagKing00(2,2); resetFlagKing00(3,2);
//setPMove();
RefreshDesk(WPiece,BPiece);
end;
procedure SelectPiece(APiece:array of  UInt64;num: Integer);
var
i,j,num1: Integer;
begin
SelectFigure := -1;
RefreshDesk(WPiece,BPiece);

                 for i := 0 to 5 do  begin
                       if (MaskOneBit[num] and APiece[i])>0 then  begin
                   SelectFigure := i;
                   if MirrorP then begin
                     num1:=ABS(num-63);
                   end else num1:=num;
                   lightPiece(num1);
//                   t1:=RDTSC;
//                   Unit2.AllMove(WPiece,BPiece,ColorMove);
//                   t2:=RDTSC-t1;
//                   ShowMessage(IntToStr(t2));
                   MP:=Unit2.AllAttack(WPiece,BPiece,MaskOneBit[num],ColorMove,true);
                   DrawMoveBox(MP); break;
                       end;
                  end;
if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin 
Xmouse:=X+BoardChess.Left;Ymouse:=Y+BoardChess.Top;
NumPoz:= ((X-20) div 60)+8*((Y-24) div 60);
if MirrorP then NumPoz:=ABS(NumPoz-63);
end;
procedure DelPieceFrom (OnePiece:UInt64;col:Integer);
var
i: Integer;
begin
 case col of
     0:begin
          for i := 0 to 5 do  begin
             if (WPiece[i] and OnePiece)>0 then begin
                WPiece[i]:=WPiece[i] xor OnePiece;exit;
             end;
          end;
     end;
     1:begin
         for i := 0 to 5 do  begin
            if (BPiece[i] and OnePiece)>0 then begin
              BPiece[i]:=BPiece[i] xor OnePiece;exit;
            end;
         end;
     end;
 end;
end;
procedure TBoardChess.FEN1Click(Sender: TObject);
 var pos : string;
begin
 pos:= InputBox(' ', ' FEN ', 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR');
 FenToU64(pos);
end;

procedure TBoardChess.FormCreate(Sender: TObject);
begin
 init(0);
  Screen.Cursors[100]:=LoadCursor(HInstance,'WK');
  Screen.Cursors[101]:=LoadCursor(HInstance,'WQ');
  Screen.Cursors[102]:=LoadCursor(HInstance,'WR');
  Screen.Cursors[103]:=LoadCursor(HInstance,'WB');
  Screen.Cursors[104]:=LoadCursor(HInstance,'WN');
  Screen.Cursors[105]:=LoadCursor(HInstance,'WP');
  Screen.Cursors[106]:=LoadCursor(HInstance,'BK');
  Screen.Cursors[107]:=LoadCursor(HInstance,'BQ');
  Screen.Cursors[108]:=LoadCursor(HInstance,'BR');
  Screen.Cursors[109]:=LoadCursor(HInstance,'BB');
  Screen.Cursors[110]:=LoadCursor(HInstance,'BN');
  Screen.Cursors[111]:=LoadCursor(HInstance,'BP');
 MenuArray[0]:=N6;
 MenuArray[1]:=N7;
 MenuArray[2]:=N8;
 MenuArray[3]:=N9;
 MenuArray[4]:=N10;
 MenuArray[5]:=N11;
 MenuArray[6]:=N12;
 MenuArray[7]:=N13;
 MenuArray[8]:=N14;
 MenuArray[9]:=N15;
 MenuArray[10]:=N16;
 MenuArray[11]:=N17;

end;

procedure TBoardChess.QweenClick(Sender: TObject);
begin
Qween.Checked:=true;
Rook.Checked:=false;
Bishop.Checked:=false;
Knight.Checked:=false;
end;
procedure TBoardChess.RookClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=true;
Bishop.Checked:=false;
Knight.Checked:=false;
end;
procedure TBoardChess.STOP1Click(Sender: TObject);
begin
 Unit2.stopbool:=true;
end;

procedure TBoardChess.BishopClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=false;
Bishop.Checked:=true;
Knight.Checked:=false;
end;
procedure TBoardChess.KnightClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=false;
Bishop.Checked:=false;
Knight.Checked:=true;
end;
procedure TBoardChess.N21Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 2');
Unit2.dmax:=3;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N22Click(Sender: TObject);
begin
 FenToU64('r3k2r/p1ppqpb1/bn2pnp1/3PN3/1p2P3/2N2Q1p/PPPBBPPP/R3K2R');
 if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N23Click(Sender: TObject);
begin
 MovPriore:= InputBox('  ', '  (e2-e4)', MovPriore);
end;

procedure TBoardChess.N2Click(Sender: TObject);
var
b:boolean;
i:integer;
s:string;
begin
if NewVar then exit;
//s:=returnStrMove;
dmax:=dmax+1;
if dmax>depth then dmax:=depth;
//b:=undoOneMove();
//       for i := 0 to 5 do begin
//        WPiece[i]:=returnPlaceOnePiece(0,i);
//        BPiece[i]:=returnPlaceOnePiece(1,i);
//        end;
RefreshDesk(WPiece,BPiece);
if MirrorP then MirrorDesc (); 
//AllAttack(WPiece,BPiece,0,ColorMove,false);
//if s<>'' then changeMove ();

if not b then begin
changeMove ();

end else begin
BoardChess.N3.Checked:=false;
BotW:=false;
BoardChess.N19.Checked:=false;
BotB:=false;
end;

end;

procedure BlackBolwan();//
begin

end;
procedure WhiteBolwan();//
begin

end;

procedure TBoardChess.N31Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 3');
Unit2.dmax:=4;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N32Click(Sender: TObject);
begin
 FenToU64('8/2p5/3p4/KP5r/1R3p1k/8/4P1P1/8');
 if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N3Click(Sender: TObject);
var
i,f:integer;
begin
BoardChess.SelectBox.Visible:=false;
RefreshDesk(WPiece,BPiece);
if MirrorP then MirrorDesc ();
if N3.Checked then begin
   BotW:=true;
   if ColorMove=0 then begin
       WhiteBolwan();
   end;
end else begin
   BotW:=false;
end;

end;

procedure TBoardChess.N41Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 4');
Unit2.dmax:=5;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N42Click(Sender: TObject);
begin
 FenToU64('r3k2r/Pppp1ppp/1b3nbN/nP6/BBP1P3/q4N2/Pp1P2PP/R2Q1RK1');
 if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N4Click(Sender: TObject);
var
i:Integer;
begin
   if BoardChess.Cursor<100 then  begin
      for i := 1 to 5 do begin
   WPieceStart[i]:=0;
   BPieceStart[i]:=0;
       end;
   init(0);
   end;
RefreshDesk(WPiece,BPiece);
if MirrorP then MirrorDesc ();
Application.ProcessMessages;
BoardChess.FigureMenu.Popup(BoardChess.Left,BoardChess.Top);
//BoardChess.FigureMenu.Popup(0,0);
end;


procedure TBoardChess.N51Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 5');
Unit2.dmax:=6;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N52Click(Sender: TObject);
begin
FenToU64('rnbq1k1r/pp1Pbppp/2p5/8/2B5/8/PPP1NnPP/RNBQK2R');
if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N5Click(Sender: TObject);
var
f:integer;
begin
 BoardChess.SelectBox.Visible:=false;
 clic:=0;
 MirrorBoard ();
if MirrorP then begin
MirrorP:=false;
end else MirrorP:=true;
RefreshDesk(WPiece,BPiece);
if MirrorP then begin
MirrorDesc ();
f:=0;
end else  f:=500;
 case ColorMove of
             0:begin
                BoardChess.Lamp.Top:=0+f;
                BoardChess.cheh.Top:=0+f;
                BoardChess.mat.Top:=0+f;
              end;
             1:begin
                BoardChess.Lamp.Top:=500-f;
                BoardChess.cheh.Top:=500-f;
                BoardChess.mat.Top:=500-f;
               end;
 end;
end;
procedure TBoardChess.N61Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 6');
Unit2.dmax:=7;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N62Click(Sender: TObject);
begin
FenToU64('r4rk1/1pp1qppp/p1np1n2/2b1p1B1/2B1P1b1/P1NP1N2/1PP1QPPP/R4RK1');
if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N6Click(Sender: TObject);
var
i:integer;
begin
   for i := 0 to 11 do begin
      if MenuArray[i]=Sender then BoardChess.Cursor:=100+i;
   end;
end;

procedure TBoardChess.N71Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 7');
Unit2.dmax:=8;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure TBoardChess.N81Click(Sender: TObject);
begin
BoardChess.PerftResult.Enabled:=false;
BoardChess.Memo1.Lines.Clear;
BoardChess.Memo1.Lines.Add('Perft = '+' 8');
Unit2.dmax:=9;
Unit2.init;
Unit2.stopbool:=false;
Unit2.Perft(WPiece,BPiece,ColorMove,1);
BoardChess.PerftResult.Enabled:=true;
RefreshDesk(WPiece,BPiece);
end;

procedure setPos();
begin
 //AllAttack(WPiece,BPiece,MaskOneBit[NumPoz],ColorMove,true);
  case BoardChess.Cursor of
    100:begin
         if BPiece[0]<>MaskOneBit[NumPoz] then  begin
          DelPieceFrom (MaskOneBit[NumPoz],0);
          DelPieceFrom (MaskOneBit[NumPoz],1);
          WPiece[0]:=MaskOneBit[NumPoz];
         end;

    end;
    101,102,103,104:begin
         //if returnNFigure(0)<16 then  begin
         DelPieceFrom (MaskOneBit[NumPoz],0);
         DelPieceFrom (MaskOneBit[NumPoz],1);
         WPiece[BoardChess.Cursor-100]:=WPiece[BoardChess.Cursor-100] or MaskOneBit[NumPoz];
         //end;
    end;
    105:begin
         //if returnNFigure(0)<16 then  begin
         DelPieceFrom (MaskOneBit[NumPoz],0);
         DelPieceFrom (MaskOneBit[NumPoz],1);
         if (MaskOneBit[NumPoz] and 18374686479671623680)=0 then begin
             if (MaskOneBit[NumPoz] and 255)=0 then begin
                WPiece[5]:=WPiece[5] or MaskOneBit[NumPoz];
             end;
         end;
         //end;
    end;
    106:begin
         if WPiece[0]<>MaskOneBit[NumPoz] then  begin
          DelPieceFrom (MaskOneBit[NumPoz],0);
          DelPieceFrom (MaskOneBit[NumPoz],1);
          BPiece[0]:=MaskOneBit[NumPoz];
         end;
    end;
    107,108,109,110:begin
         //if returnNFigure(1)<16 then  begin
         DelPieceFrom (MaskOneBit[NumPoz],0);
         DelPieceFrom (MaskOneBit[NumPoz],1);
         BPiece[BoardChess.Cursor-106]:=BPiece[BoardChess.Cursor-106] or MaskOneBit[NumPoz];
         //end;
    end;
    111:begin
         //if returnNFigure(1)<16 then  begin
         DelPieceFrom (MaskOneBit[NumPoz],0);
         DelPieceFrom (MaskOneBit[NumPoz],1);
         if (MaskOneBit[NumPoz] and 18374686479671623680)=0 then begin
             if (MaskOneBit[NumPoz] and 255)=0 then begin
                BPiece[5]:=BPiece[5] or MaskOneBit[NumPoz];
             end;
         end;
        // end;
    end;
  end;
  if WPiece[0]=0 then begin
         DelPieceFrom (WPieceStart[0],0);
         DelPieceFrom (WPieceStart[0],1);
         WPiece[0]:=WPieceStart[0];
  end else WPieceStart[0]:=WPiece[0];
  if BPiece[0]=0 then begin
         DelPieceFrom (BPieceStart[0],0);
         DelPieceFrom (BPieceStart[0],1);
         BPiece[0]:=BPieceStart[0];
  end else BPieceStart[0]:=BPiece[0];
 RefreshDesk(WPiece,BPiece);
 if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.BoardClick(Sender: TObject);
var
i,j:Integer;
begin
   BoardChess.Caption:='CHESS';
if NumPoz>63 then exit;
if NumPoz<0 then exit;
if BoardChess.Cursor>=100 then  begin
  BoardChess.Caption:='    ';
  setPos();
  exit;
end;
if BotB then if ColorMove=1 then exit;//
if BotW then if ColorMove=0 then exit;
BoardChess.SelectBox.Visible:=false;
 if clic=1 then  begin
             ToFrom:=NumPoz;
             clic:=0;
 if (MP and MaskOneBit[ToFrom])=0  then  begin
     RefreshDesk(WPiece,BPiece);
     if MirrorP then MirrorDesc (); 
     exit;
 end;
       case ColorMove  of
       0:begin
          if (WPiece[5] and MaskOneBit[FromTo] and 65280)>0 then  begin
           BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
           BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
         end;
       end;
       1:begin
         if (BPiece[5] and MaskOneBit[FromTo] and 71776119061217280)>0 then  begin
            BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
            BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
         end;
       end;
      end;
              if Qween.Checked then SelectPawnHi:=1;
              if Rook.Checked then SelectPawnHi:=2;
              if Bishop.Checked then SelectPawnHi:=3;
              if Knight.Checked then SelectPawnHi:=4;
if
not Unit2.MovePiceFromTo(WPiece,BPiece,MaskOneBit[FromTo],MaskOneBit[ToFrom],ColorMove,SelectPawnHi,true)
then begin
 RefreshDesk(WPiece,BPiece);
 if MirrorP then MirrorDesc ();
exit;
end;
  //NewVar:=false;
 // BoardChess.Board.ShowHint:=false;
         for i := 0 to 5 do begin
        WPiece[i]:=Unit2.WPiece[i];
        BPiece[i]:=Unit2.BPiece[i];
        end;
 RefreshDesk(WPiece,BPiece);
 if MirrorP then MirrorDesc ();
  //MP:=AllAttack(WPiece,BPiece,MaskOneBit[ToFrom],ColorMove,false);
 changeMove ();
 if BotB then BlackBolwan();//
 if BotW then WhiteBolwan();
             exit;
 end;//clic=1
 case ColorMove  of
       0:begin
          if not BotW then SelectPiece(WPiece,NumPoz);
        end;
       1:begin
         if not BotB then SelectPiece(BPiece,NumPoz);//
        end;
 end;
 if clic=0  then  begin
       if SelectFigure>=0 then  begin
            FromTo:=NumPoz;
            clic:=1;
       end;
 end;
end;


procedure NewPosView(WP,BP:array of  UInt64;col:integer);
var
i:integer;
begin
   for i := 0 to 5 do begin
    WPieceStart[i]:=WP[i];
    BPieceStart[i]:=BP[i];
 end;
init(col);
RefreshDesk(WP,BP);
if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N110Click(Sender: TObject);
begin
 FenToU64('rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR');
 if MirrorP then MirrorDesc ();
end;

procedure TBoardChess.N18Click(Sender: TObject);
var
s:string;
begin
// BoardChess.Cursor:=crDefault;
 depth:=2;
 //setPMove();
 NewPosView(WPiece,BPiece,0);
 try
 s:=U64toFen(WPiece,BPiece,ColorMove);     
 clipboard.SetTextBuf(PChar(s));
if Clipboard.HasFormat (CF_TEXT) then  begin
   BoardChess.Caption:='    ';
end else Clipboard.Clear;

 finally

 end;

end;

procedure TBoardChess.N19Click(Sender: TObject);
begin
 BoardChess.SelectBox.Visible:=false;
RefreshDesk(WPiece,BPiece);
if MirrorP then MirrorDesc ();
if N19.Checked then begin
   BotB:=true;
   if ColorMove=1 then begin
       BlackBolwan();
   end;
end else begin
   BotB:=false;
end;
end;

procedure DrawLine(a,b:Integer;WP,BP:array of  UInt64);
var
bmp: tbitmap;
begin
ClearDesk ();
DrawPieceBoard(WP,0);
DrawPieceBoard(BP,1);
try
 bmp := tbitmap.Create;
 bmp.Height:=506;
 bmp.Width:=501;
 bmp.Canvas.CopyRect(rect(0,0,506,501),BoardChess.Board.Canvas,rect(0,0,506,501));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 bmp.Canvas.Pen.Color:=clRed;
 bmp.Canvas.Pen.Width:=5;
 bmp.Canvas.Pen.Mode:=pmNop;
 bmp.Canvas.LineTo(56+60*(a and 7),51+60*(a shr 3));
 bmp.Canvas.Pen.Mode:=pmCopy;
 bmp.Canvas.LineTo(56+60*(b and 7),51+60*(b shr 3));
 BoardChess.Board.Canvas.Draw(0, 0, bmp);
 if MirrorP then MirrorDesc ();
finally
 bmp.free;
end;
end;

end.
